<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty {mt_rand} function plugin
 *
 * Type:     function<br />
 * Name:     swphp_hrefpagina<br />
 * Purpose:  get href to pagina in Simple Web PHP Edicion Administrada<br />
 * @link
 * @author José Carlos Cruz Parra programadorphpfreelance.com
 * @param array
 * @param Smarty
 */
function smarty_function_swphp_hrefpagina($params, &$smarty)
{
	global $swphp_pagina;

	$pagina_id = isset($params['pagina_id']) ? $params['pagina_id'] : $swphp_pagina->GetId();
	$idioma_id = isset($params['idioma_id']) ? $params['idioma_id'] : SWPHP_IDIOMA_POR_DEFECTO;

	return SWPHP::_GetHrefPagina($pagina_id, $idioma_id);
}

/* vim: set expandtab: */

?>