<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty number_format modifier plugin
 *
 * Type:     modifier<br>
 * Name:     currency_format<br>
 * Purpose:  format a number with n decimals
 * @link http://www.internia.net/
 * @author   José Carlos Cruz Parra AKA Internia
 * @param int
 * @param bool
 * @param bool
 * @return string
 */
function smarty_modifier_decimales_format($amount, $decimalplaces=2, $decimalpoint=",")
{
    return number_format($amount, $decimalplaces, $decimalpoint, '');
}

/* vim: set expandtab: */

?>
