<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2012-06-10
 * para Francisco Ortega
 *
 */
class KPTL_Calculon
{
	public static function getSaldo($user_id, $dia)
    {
		global $db;

    	if($db->GetValueQuery("SELECT COUNT(*) FROM ".SWPHP_DBPREFIX."kptl_movimientos WHERE user_id = '{$user_id}' AND SUBSTRING(fechayhora,1,10) <= '{$dia}'", false) > 0)
		{
			return intval($db->GetValueQuery("SELECT saldo FROM ".SWPHP_DBPREFIX."kptl_movimientos WHERE user_id = '{$user_id}' AND SUBSTRING(fechayhora,1,10) <= '{$dia}' ORDER BY fechayhora DESC, id DESC LIMIT 1", false));
		}

		return 0;
    }

    public static function getValoracion($user_id, $dia)
    {
		global $db;

    	return intval($db->GetValueQuery("SELECT puntos FROM ".SWPHP_DBPREFIX."kptl_valoraciones WHERE user_id = '{$user_id}' AND SUBSTRING(fechayhora,1,10) = '{$dia}' ORDER BY fechayhora DESC, id DESC LIMIT 1", false));
    }

    public static function getSaldoMedia($dia)
    {
    	global $db;

    	$aux = 0;
		$c = 0;
		$rows = $db->GetRows("SELECT id FROM ".SWPHP_DBPREFIX."kptl_usuarios WHERE SUBSTRING(fechayhoraalta,1,10) <= '{$dia}'", true, false);
		if(is_array($rows) && sizeof($rows) > 0)
		{
			foreach($rows as $row)
			{
				$aux += KPTL_Calculon::getSaldo($row['id'], $dia);
				$c++;
			}

			return $aux / $c;
		}

		return 0;
    }

    public static function getValoracionMedia($dia)
    {
    	global $db;

    	$aux = 0;
		$c = 0;
		$rows = $db->GetRows("SELECT id FROM ".SWPHP_DBPREFIX."kptl_usuarios WHERE SUBSTRING(fechayhoraalta,1,10) <= '{$dia}'", true, false);
		if(is_array($rows) && sizeof($rows) > 0)
		{
			foreach($rows as $row)
			{
				$aux += KPTL_Calculon::getValoracion($row['id'], $dia);
				$c++;
			}

			return $aux / $c;
		}

		return 0;
    }

    public static function getSaldoPeriodo($user_id, $ini, $fin)
    {
		$dias = array();
    	$cuantos = 0;

		$date = descomponerfecha($ini);

		while($ini <= $fin)
		{
			$cuantos++;

			$dias[$ini] = KPTL_Calculon::getSaldo($user_id, $ini);

			$ini = date("Y-m-d", mktime(0, 0, 0, $date["m"], $date["d"]+$cuantos, $date["Y"]));
		}

		return $cuantos > 0 ? round(array_sum($dias)/$cuantos) : 0;
    }

    public static function getValoracionPeriodo($user_id, $ini, $fin)
    {
		$dias = array();
    	$cuantos = 0;

		$date = descomponerfecha($ini);

		while($ini <= $fin)
		{
			$cuantos++;

			$dias[$ini] = KPTL_Calculon::getValoracion($user_id, $ini);

			$ini = date("Y-m-d", mktime(0, 0, 0, $date["m"], $date["d"]+$cuantos, $date["Y"]));
		}

		return $cuantos > 0 ? round(array_sum($dias)/$cuantos) : 0;
    }

    public static function getSaldoPeriodoMedia($ini, $fin)
    {
		global $db;

		$aux = 0;
		$c = 0;
		$rows = $db->GetRows("SELECT id FROM ".SWPHP_DBPREFIX."kptl_usuarios WHERE SUBSTRING(fechayhoraalta,1,10) <= '{$dia}'", true, false);
		if(is_array($rows) && sizeof($rows) > 0)
		{
			foreach($rows as $row)
			{
				$aux += KPTL_Calculon::getSaldoPeriodo($row['id'], $ini, $fin);
				$c++;
			}

			return $aux / $c;
		}

		return 0;
    }

    public static function getValoracionPeriodoMedia($ini, $fin)
    {
		global $db;

		$aux = 0;
		$c = 0;
		$rows = $db->GetRows("SELECT id FROM ".SWPHP_DBPREFIX."kptl_usuarios WHERE SUBSTRING(fechayhoraalta,1,10) <= '{$dia}'", true, false);
		if(is_array($rows) && sizeof($rows) > 0)
		{
			foreach($rows as $row)
			{
				$aux += KPTL_Calculon::getValoracionPeriodo($row['id'], $ini, $fin);
				$c++;
			}

			return $aux / $c;
		}

		return 0;
    }
}
?>