<?php
/**
 * José Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2012-04-08
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/kapitaltruth/inc/valoraciones.inc.php
 *
 */

$g = isset($_GET['g']) ? trim($_GET['g']) : '';
$q = isset($_GET['q']) ? trim($_GET['q']) : '';

$paginador = SWPHP::_CrearPaginador('valoraciones');
$paginador->SetParam('etiqueta', l('usuario', 'kapitaltruth'));
$paginador->Fill($kptl_user->Conjunto2Query($g, false, sprintf("WHERE CONCAT_WS(' ', u.nick, ku.nombre) LIKE _utf8 '%%%s%%' COLLATE utf8_general_ci", addcslashes(utf8_encode($q), "'"))));
$paginador->SetParam('campos', array(
	'nick'=>array('label'=>l('Alias', 'kapitaltruth')),
	'nombre'=>array('label'=>l('Nombre', 'kapitaltruth')),
	'controles'=>array('label'=>'', 'style'=>'width:120px', 'class'=>'center', 'orderby'=>false),
	));
$paginador->SetParam('camposEstrictos', true);
$paginador->SetParam('buscador', false);
$paginador->SetParam('formato_tabla', array(
	'class'=>'listado middle',
	'width'=>'100%',
	'cellpadding'=>'0',
	'cellspacing'=>'0',
	'border'=>'0',
	));

function applyToReg(&$reg, $key)
{
	$reg['controles'] = '<a id="a_valorar'.$reg['id'].'" href="javascript:CargarValoracion('.$reg['id'].')" title="'.l('Valorar a').' '.$reg['nick'].'">'.l('Valorar', 'kapitaltruth').'</a>';
}
$paginador->SetParam('applyToRegs', 'applyToReg');

$valoraciones['nunca'] = $kptl_user->GetConjuntoNunca(true);
$valoraciones['antes'] = $kptl_user->GetConjuntoAntes(true);
$valoraciones['todos'] = $kptl_user->GetConjuntoTodos(true);

$smarty->assign(array(
	'g'=>$g,
	'q'=>$q,
	'valoraciones'=>$valoraciones,
	'paginador'=>$paginador,
	));

$kptl_template = SWPHP::_GetModuleTemplate('inc/valoraciones.tpl');
?>