<?php
/**
 * Armando Servillera Torres
 * www.pagina-web-barata.com
 * 2011-06-23
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/modulos/admin/index.php
 *
 */

$id = isset($_GET["id"]) && $_GET['id'] ? intval($_GET["id"]) : 0;
$op = isset($_GET['op']) && $_GET['op'] ? $_GET['op'] : "";
$m = isset($_GET['m']) && $_GET['m'] ? $_GET['m'] : "";

if($id > 0)
{
	//Los módulos core no admiten ciertas operaciones
	$core = $db->GetValueQuery("SELECT core FROM ".SWPHP_DBPREFIX."modulos WHERE id = '{$id}'");
	if($core && in_array($op, array("edit", "upd", "des")))
	{
		$op = "";
	}
}

$mostrarprincipal = true;

switch($op)
{
	case "edit":
		$registro = $db->GetRow("SELECT id,titulo,icono FROM ".SWPHP_DBPREFIX."modulos WHERE id = '{$id}'");
		$smarty->assign("iconos", SWPHP::_GetIconos());
		$smarty->assign("registro", $registro);
		$admin_template = "{$swphp_module_templates_dir}admin/modulo.tpl";
		$mostrarprincipal = false;
		break;
	case "new":
		//Nada, no hay "new"
		break;
	case "upd":
		if(modulos_validarDatos($_POST))
		{
			SWPHP::_ExecuteQuery(
				buildQuery_Update(modulos_prepararDatos($_POST, $id), SWPHP_DBPREFIX."modulos", $id),
				"Modulo actualizado correctamente",
				"No se ha podido actualizar el registro"
			);
		}
		break;
	case "reg":
		//Nada, no hay "reg"
		break;
	case "ins":
		modulos_instalarModulo($m);
		break;
	case "reins":
		modulos_reinstalarModulo($m);
		break;
	case "des":
		modulos_desinstalarModulo($m);
		break;
	case "permisos":
		$modulo = $db->GetRow("SELECT id,titulo,icono FROM ".SWPHP_DBPREFIX."modulos WHERE id = '{$id}'");
		$modulo["permisos"] = $db->GetArrayForHTMLSelectQuery("SELECT perfil_id, permiso_id FROM ".SWPHP_DBPREFIX."modulos_perfiles WHERE modulo_id = '{$modulo["id"]}'");
		$perfiles = SWPHP::_GetPerfilesRows(0, 999999, 'p.id ASC');
		$permisos = $db->GetRows("SELECT id, nombre FROM ".SWPHP_DBPREFIX."permisos ORDER BY id ASC");

		$smarty->assign("perfiles", $perfiles);
		$smarty->assign("permisos", $permisos);
		$smarty->assign("modulo", $modulo);

		$admin_template = "{$swphp_module_templates_dir}admin/asignarpermisos.tpl";
		$mostrarprincipal = false;
		break;
}

//TODO: esto se copió del módulo permisos, adaptarlo a la gestión de los permisos de un solo módulo
//Recibir formulario de asignación de permisos
if(isset($_POST['permisos']) && is_array($_POST['permisos']))
{
	$ok = true;
	$permisos = $_POST['permisos'];
	foreach($permisos as $modulo_id=>$perfiles)
	{
		foreach($perfiles as $perfil_id=>$permiso_id)
		{
			$modulo_id = intval($modulo_id);
			$perfil_id = intval($perfil_id);
			$permiso_id = intval($permiso_id);

			$query = sprintf("UPDATE ".SWPHP_DBPREFIX."modulos_perfiles SET permiso_id = '%u' WHERE perfil_id = '%u' AND modulo_id = '%u'", $permiso_id, $perfil_id, $modulo_id);

			//SWPHP::_Msg($query);

			$ok = $ok && SWPHP::_ExecuteQuery(
				$query,
				"",
				"No se pudo actualizar el permiso para el perfil {$perfil_id} del módulo {$modulo_id}"
				);
		}
	}

	if($ok)
	{
		SWPHP::_Msg("Los permisos se asignaron correctamente", "check");
	}
	else
	{
		SWPHP::_Msg("Los permisos se asignaron con algún error", "aviso");
	}
}

if($mostrarprincipal)
{
	$carpetas = getDirs(SWPHP_MODULES_DIR);
	$modulos = array();

	foreach($carpetas as $carpeta)
	{
		$modulo = SWPHP::_GetModuloInfo($carpeta);

		if($db->Exists($carpeta, 'clave', SWPHP_DBPREFIX.'modulos'))
		{
			$instalado = true;

			$row = $db->GetRow(sprintf("SELECT id, titulo, icono, activo, core, version AS versionIns FROM ".SWPHP_DBPREFIX."modulos WHERE clave = '%s'", addcslashes($carpeta, "'")));

			$id = $row['id'];

			$modulo['id'] = $id;
			$modulo['titulo'] = $row['titulo'];
			$modulo['icono'] = $row['icono'];

			$modulo['instalado'] = SWPHP::_Icon("accept.png", 16);
			$modulo['permisos'] = "<a href=\"".SWPHP_ADMIN_DIR.$swphp_mod_clave."/?op=permisos&amp;id={$id}\">".SWPHP::_Icon("key.png", 16, array("alt"=>"Asignar permisos", "title"=>"Asignar permisos. {$id}"))."</a>";

			if($row['activo'])
			{
				/*
				$hrefIns = $row['core'] ? "javascript:ModuloCore('reinstalar')" : sprintf("javascript:ModuloReinstalar('%s')", addcslashes($carpeta, "'"));
				$modulo['instalado'] .= " <a id=\"aInstalar{$id}\" class=\"mini\" href=\"{$hrefIns}\">Reinstalar</a>";
				*/
				//if(!$row['core'])
				//{
					$hrefIns = sprintf("javascript:ModuloReinstalar('%s')", addcslashes($carpeta, "'"));
					$modulo['instalado'] .= " <a id=\"aInstalar{$id}\" class=\"mini\" href=\"{$hrefIns}\">Reinstalar</a>";
				//}

				$titleAct = 'Desactivar';
				$iconAct = SWPHP::_Icon("green_button.png", 16, array("alt"=>"Desactivar"));
				$hrefAct = $row['core'] ? "javascript:ModuloCore('desactivar')" : "javascript:ModuloActivar({$id})";
			}
			else
			{
				$hrefIns = $row['core'] ? "javascript:ModuloCore('desinstalar')" : sprintf("javascript:ModuloDesinstalar('%s')", addcslashes($carpeta, "'"));
				$modulo['instalado'] .= " <a id=\"aInstalar{$id}\" class=\"mini\" href=\"{$hrefIns}\">Desinstalar</a>";

				$titleAct = 'Activar';
				$iconAct = SWPHP::_Icon("red_button.png", 16, array("alt"=>"Activar"));
				$hrefAct = $row['core'] ? "javascript:ModuloCore('activar')" : "javascript:ModuloActivar({$id})";
			}

			$modulo['activo'] = "<a id=\"aActivar{$id}\" href=\"{$hrefAct}\" title=\"{$titleAct}\">{$iconAct}</a>";
			$modulo['core'] = $row['core'] ? SWPHP::_Icon("forbidden.png", 16, array("title"=>"¡Es un módulo core!")) : "<a href=\"".SWPHP_ADMIN_DIR.$swphp_mod_clave."/?op=edit&amp;id={$id}\">".SWPHP::_Icon("edit.png", 16, array("alt"=>"Editar modulo", "title"=>"Editar Id. {$id}"))."</a>";
			$modulo['versionIns'] = $row['versionIns'];
		}
		else
		{
			$instalado = false;

			$modulo['id'] = '';
			$modulo['instalado'] = SWPHP::_Icon("remove.png", 16)." <a id=\"aInstalar{$id}\" class=\"mini\" href=\"".SWPHP_ADMIN_DIR.$swphp_mod_clave."/?op=ins&amp;m={$carpeta}\">Instalar</a>";
			$modulo['permisos'] = '';
			$modulo['activo'] = SWPHP::_Icon("blank.png", 16);
			$modulo['core'] = SWPHP::_Icon("blank.png", 16);
			$modulo['versionIns'] = '';
		}

		//Para el listado
		//le paso sólo los elementos que voy a utilizar y en el orden adecuado
		$modulos[] = array(
			'id'=>$modulo['id'],
			'icono'=>SWPHP::_Icon($modulo['icono'], 24),
			'titulo'=>$modulo['titulo'],
			'carpeta'=>$carpeta,
			'clave'=>$modulo['clave'],
			'version'=>$modulo['version'].sprintf(' <span class="%s">%s</span>', $modulo['versionIns'] ? ($modulo['version'] == $modulo['versionIns'] ? 'verde' : 'rojo') : 'azul', $modulo['versionIns'] ? $modulo['versionIns'] : '&nbsp;'),
			'instalado'=>$modulo['instalado'],
			'controles'=>$instalado ? $modulo['activo']." ".$modulo['core']." ".$modulo['permisos'] : SWPHP::_Icon('delete.png', 16)." <a class=\"mini\" id=\"aBorrar{$carpeta}\" href=\"javascript:ModuloBorrar('{$carpeta}')\" title=\"Borrar por completo\">Borrar</a>",
			);

		//Para evitar problemas con el isset que hay más arriba dentro de este mismo bucle
		unset($modulo);
	}

	foreach($modulos as $key=>$val)
	{
	    $titulos[$key] = $val['titulo'];
	}
	array_multisort($titulos, SORT_ASC, $modulos);

	$paginador = SWPHP::_CrearPaginador('modulos');
	$paginador->SetParam('etiqueta', 'módulo');
	$paginador->Fill($modulos);
	$paginador->SetParam('campos', array(
		'id'=>array("label"=>"Id.", "class"=>"numeric"),
		'icono'=>array("label"=>"", "orderby"=>false),
		'titulo'=>array("label"=>"Título"),
		'carpeta'=>array("label"=>"Carpeta"),
		'clave'=>array("label"=>"Clave"),
		'version'=>array("label"=>"Versión", "orderby"=>false, "class"=>"center"),
		'instalado'=>array("label"=>"Instalado"),
		'controles'=>array("label"=>"", "orderby"=>false)
		));

	/*
	$paginador->SetParam('buscador', array(
		'titulo'=>'Título',
		'carpeta'=>'Carpeta',
		'clave'=>'Clave',
		'version'=>'Versión',
		'instalado'=>'Instalado',
		'activo'=>'Activos',
		'id'=>'Id.',
		));
	*/

	$admin_template = "{$swphp_module_templates_dir}admin/modulos.tpl";

	$smarty->assign('paginador', $paginador);
}
?>