<?php
/* swphp:modulo noticias */

SWPHP::_ExecuteQuery("SET NAMES 'utf8'", "", "");

$queries = array(
	"INSERT INTO ".SWPHP_DBPREFIX."config (id,variable,valor,concepto,info,texto) VALUES (NULL,'maxlenintro','255','noticias','tag=input;type=text;size=5;maxlength=5;class=numeric','Logitud máxima para la introducción')",
	);

$ok = true;
foreach($queries as $query)
{
	if(!SWPHP::_ExecuteQuery($query, "", "ERROR ejecutando:<br />{$query}"))
	{
		$ok = false;
		break;
	}
}

if($ok)
{
	//preparar multilenguaje

	$query = "CREATE TABLE IF NOT EXISTS ".SWPHP_DBPREFIX."noticias_idiomas (
	  noticia_id int(10) unsigned NOT NULL,
	  idioma_id smallint(5) unsigned NOT NULL,
	  titulo varchar(120) NOT NULL DEFAULT '',
	  introduccion text NOT NULL DEFAULT '',
	  contenido text NOT NULL DEFAULT '',
	  friendly varchar(120) NOT NULL DEFAULT '',
	  keywords varchar(255) NOT NULL DEFAULT '',
	  tags varchar(255) NOT NULL DEFAULT '',
	  PRIMARY KEY (noticia_id, idioma_id),
	  UNIQUE KEY (friendly, idioma_id)
	) DEFAULT CHARSET=utf8;";
	//SWPHP::_Msg(SWPHP::_HtmlEntities($query), 'info');
	$ok &= SWPHP::_ExecuteQuery($query, '', "ERROR ejecutando:<br />{$query}");

	$idiomas = $db->GetRows("SELECT id, nombre, codigoiso FROM ".SWPHP_DBPREFIX."idiomas WHERE activo = '1'", true, false);
	foreach($idiomas as $idioma)
	{
		//SWPHP::_Msg("Idioma Id. {$idioma['id']} - {$idioma['codigoiso']} - {$idioma['nombre']}", 'info');

		$rows = $db->GetRows("SELECT id, titulo, introduccion, contenido, friendly, keywords, tags FROM ".SWPHP_DBPREFIX."noticias", true, false);
		foreach($rows as $row)
		{
			//SWPHP::_Msg("Noticia Id. {$row['id']} - {$row['titulo']}", 'info');

			$data = array(
				'noticia_id'=>$row['id'],
				'idioma_id'=>$idioma['id'],
				'titulo'=>$row['titulo'],
				'introduccion'=>$row['introduccion'],
				'contenido'=>$row['contenido'],
				'friendly'=>$row['friendly'],
				'keywords'=>$row['keywords'],
				'tags'=>$row['tags'],
				);

			$query = buildQuery_Insert($data, SWPHP_DBPREFIX.'noticias_idiomas');
			//SWPHP::_Msg(SWPHP::_HtmlEntities($query), 'info');
			$ok &= SWPHP::_ExecuteQuery($query, '', "ERROR ejecutando:<br />{$query}");
		}
	}

	if($ok)
	{
		$queries = array(
			"ALTER TABLE ".SWPHP_DBPREFIX."noticias DROP titulo",
			"ALTER TABLE ".SWPHP_DBPREFIX."noticias DROP introduccion",
			"ALTER TABLE ".SWPHP_DBPREFIX."noticias DROP contenido",
			"ALTER TABLE ".SWPHP_DBPREFIX."noticias DROP friendly",
			"ALTER TABLE ".SWPHP_DBPREFIX."noticias DROP keywords",
			"ALTER TABLE ".SWPHP_DBPREFIX."noticias DROP tags",
			);
		foreach($queries as $query)
		{
			//SWPHP::_Msg(SWPHP::_HtmlEntities($query), 'info');
			$ok &= SWPHP::_ExecuteQuery($query, '', "ERROR ejecutando:<br />{$query}");
		}
	}
}


$updOk = $ok;
