<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty {interniacms_html_cancelar} function plugin
 *
 * Type:     function<br />
 * Name:     interniacms_html_cancelar<br />
 * Purpose:  build html button to cancel (go back) in Internia CMS<br />
 * @link
 * @author José Carlos Cruz Parra AKA Internia
 * @param array
 * @param Smarty
 */
function smarty_function_interniacms_html_cancelar($params, &$smarty)
{
	$url = $_SESSION["REQUEST_URI"];
	$ops = isset($params["ops"]) ? $params["ops"] : array("view","edit","new","reg","upd","del","on","off","factura");

	$arr1 = array();
	$arr2 = array();
	foreach($ops as $op)
	{
		$arr1[] = "&op={$op}";
		$arr1[] = "-op-{$op}";
		$arr2[] = "&op=";
		$arr2[] = "-op-";
	}
	return sprintf("<input type=\"button\" value=\"Cancelar\" onclick=\"javascript:window.location='%s'\" class=\"%s\" />", addcslashes(str_replace($arr1, $arr2, $url), "'"), isset($params["class"]) ? $params["class"] : "boton");
}

/* vim: set expandtab: */

?>
