<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty {mt_rand} function plugin
 *
 * Type:     function<br />
 * Name:     swphp_icon<br />
 * Purpose:  get path to icon file in Simple Web PHP Edicion Administrada<br />
 * @link
 * @author José Carlos Cruz Parra programadorphpfreelance.com
 * @param array
 * @param Smarty
 */
function smarty_function_swphp_icon($params, &$smarty)
{
	$icon = isset($params['icon']) ? $params['icon'] : '';
	$width = isset($params['width']) ? $params['width'] : '';

	if(isset($params['srconly']) && $params['srconly'])
	{
		$params = false;
	}
	else
	{
		unset($params['icon'], $params['width'], $params['srconly']);
	}

	return SWPHP::_Icon($icon, $width, $params);
}

/* vim: set expandtab: */

?>