<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty number_format modifier plugin
 *
 * Type:     modifier<br>
 * Name:     encode_hex<br>
 * Purpose:  encodes a string in hex (useful for email address)
 * @link 
 * @author   José Carlos Cruz Parra AKA Internia
 * @return string
 */
function smarty_modifier_encode_hex($str)
{
    /*
	preg_match('!^(.*)(\?.*)$!',$str,$match);
    if(!empty($match[2])) {
        $smarty->trigger_error("encode_hex: hex encoding does not work with extra attributes.");
        return;
    }
    */
    $str_encode = '';
    for ($x=0; $x < strlen($str); $x++) {
        if(preg_match('!\w!',$str[$x])) {
            $str_encode .= '%' . bin2hex($str[$x]);
        } else {
            $str_encode .= $str[$x];
        }
    }
    return $str_encode;
}

/* vim: set expandtab: */

?>
