<?php
/**
 * José Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2011-06-25
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/menuprincipal/admin/index.php
 *
 */

$id = isset($_GET["id"]) && $_GET['id'] ? intval($_GET["id"]) : 0;
$op = isset($_GET['op']) && $_GET['op'] ? $_GET['op'] : "";

$mostrarprincipal = true;

switch($op)
{
	case "up":
		SWPHP::_SubirRegistro($id, SWPHP_DBPREFIX.'menuprincipal');
		break;
	case "down":
		SWPHP::_BajarRegistro($id, SWPHP_DBPREFIX.'menuprincipal');
		break;
	case "edit":
		$registro = $db->GetRow("SELECT m.*, ur.nick AS userregistro, uu.nick AS userultima"
			." FROM ".SWPHP_DBPREFIX."menuprincipal AS m"
			." LEFT JOIN ".SWPHP_DBPREFIX."users AS ur ON ur.id = m.user_idregistro"
			." LEFT JOIN ".SWPHP_DBPREFIX."users AS uu ON uu.id = m.user_idultima"
			." WHERE m.id = '{$id}'");
		if($registro["icono"] == '')
		{
			$registro["icono"] = SWPHP_DEFAULT_ICON;
		}
		if($registro["estilo_id"] == 0)
		{
			$registro["estilo_id"] = SWPHP::_GetPorDefecto("estilos");
		}
		$registro['idiomas'] = array();
		foreach($swphp_idiomas as $idioma)
		{
			$registro['idiomas'][$idioma['id']] = $db->GetRow("SELECT textoenlace, title, url FROM ".SWPHP_DBPREFIX."menuprincipal_idiomas WHERE menuprincipal_id = '{$id}' AND idioma_id = '{$idioma['id']}'");
		}
	case "new":
		if(!isset($registro))
		{
			$registro = array('id'=>null, 'padre_id'=>0, 'pagina_id'=>0, 'icono'=>SWPHP_DEFAULT_ICON, 'estilo_id'=>SWPHP::_GetPorDefecto('estilos'));
		}
		$smarty->assign("registro", $registro);
		$smarty->assign("opciones", SWPHP::_Rows2AssocTree(SWPHP_DBPREFIX.'menuprincipal AS m'
			.' LEFT JOIN '.SWPHP_DBPREFIX.'paginas_idiomas AS pi ON pi.pagina_id = m.pagina_id AND pi.idioma_id = '.SWPHP_IDIOMA_POR_DEFECTO
			.' LEFT JOIN '.SWPHP_DBPREFIX.'menuprincipal_idiomas AS mi ON mi.menuprincipal_id = m.id AND mi.idioma_id = '.SWPHP_IDIOMA_POR_DEFECTO,
			'IF(pi.titulo != \'\', pi.titulo, mi.title)', 'm.id', 'm.padre_id', '1 ORDER BY m.padre_id, m.peso', array('0', '[Es una opción raíz]'), $registro['id']));
		$smarty->assign("paginas", SWPHP::_Rows2AssocTree(SWPHP_DBPREFIX.'paginas AS p JOIN '.SWPHP_DBPREFIX.'paginas_idiomas AS pi ON p.id = pi.pagina_id AND pi.idioma_id = '.SWPHP_IDIOMA_POR_DEFECTO, 'pi.titulo', 'p.id', 'p.padre_id', '1 ORDER BY p.padre_id, p.peso', array('', ''))); //'p.esteril = \'0\' ORDER BY p.padre_id, p.peso', array('', '')));
		$smarty->assign("iconos", SWPHP::_GetIconos());
		$smarty->assign("estilos", $db->GetRows("SELECT id, nombre FROM ".SWPHP_DBPREFIX."estilos ORDER BY nombre ASC"));
		$admin_template = "{$swphp_module_templates_dir}admin/opcion.tpl";
		$mostrarprincipal = false;

		SWPHP::_AddDocumentReady("$('.editlang').children('.lang').click(function(event){EditLangs(event);});");

		break;
	case "upd":
		if(menuprincipal_validarDatos($_POST))
		{
			$tipo = $_POST['tipo'];

			if(SWPHP::_ExecuteQuery(
				buildQuery_Update(menuprincipal_prepararDatos($_POST, $id), SWPHP_DBPREFIX."menuprincipal", $id),
				"Registro actualizado correctamente",
				"No se ha podido actualizar el registro"
				))
			{
				if($tipo == 'manual')
				{
					foreach($swphp_idiomas as $idioma)
					{
						$query = $db->Exists($idioma['id'], 'idioma_id', SWPHP_DBPREFIX.'menuprincipal_idiomas', "WHERE menuprincipal_id = '{$id}'") ?
							buildQuery_Update(menuprincipal_prepararDatosIdioma($_POST['idiomas'], $idioma['id'], $id), SWPHP_DBPREFIX."menuprincipal_idiomas", array('menuprincipal_id'=>$id, 'idioma_id'=>$idioma['id']))
							:
							buildQuery_Insert(menuprincipal_prepararDatosIdioma($_POST['idiomas'], $idioma['id'], $id), SWPHP_DBPREFIX."menuprincipal_idiomas");

						SWPHP::_ExecuteQuery(
							$query,
							'',
							"No se ha podido guardar la información en {$idioma['nombre']}"
						);
					}
				}
			}
		}
		break;
	case "reg":
		if(menuprincipal_validarDatos($_POST))
		{
			$tipo = $_POST['tipo'];

			if(SWPHP::_ExecuteQuery(
				buildQuery_Insert(menuprincipal_prepararDatos($_POST), SWPHP_DBPREFIX."menuprincipal"),
				"Registro creado correctamente",
				"No se ha podido insertar el registro"
				))
			{
				if($tipo == 'manual')
				{
					$id = $db->Insert_Id();
					foreach($swphp_idiomas as $idioma)
					{
						SWPHP::_ExecuteQuery(
							buildQuery_Insert(menuprincipal_prepararDatosIdioma($_POST['idiomas'], $idioma['id'], $id), SWPHP_DBPREFIX."menuprincipal_idiomas"),
							'',
							"No se ha podido guardar la información en {$idioma['nombre']}"
						);
					}
				}
			}
		}
		break;
}

if($mostrarprincipal)
{
	$admin_template = "{$swphp_module_templates_dir}admin/menuprincipal.tpl";

	$padre_id = 0;
	$rows = $db->GetRows("SELECT m.id, m.padre_id, m.pagina_id, m.activo, p.pagina_id AS padre_pagina_id"
		." FROM ".SWPHP_DBPREFIX."menuprincipal AS m"
		." LEFT JOIN ".SWPHP_DBPREFIX."menuprincipal AS p ON p.id = m.padre_id"
		." ORDER BY m.padre_id, m.peso, m.id");
	for($c=0,$size=sizeof($rows); $c<$size; $c++)
	{
		//Textoenlace y title
		$aux = $rows[$c]['pagina_id'] > 0 ?
			$db->GetRow("SELECT textoenlace, title"
				." FROM ".SWPHP_DBPREFIX."paginas_idiomas"
				." WHERE pagina_id = '{$rows[$c]['pagina_id']}' AND idioma_id = '".SWPHP_IDIOMA_POR_DEFECTO."'"
				)
			:
			$db->GetRow("SELECT textoenlace, title"
				." FROM ".SWPHP_DBPREFIX."menuprincipal_idiomas"
				." WHERE menuprincipal_id = '{$rows[$c]['id']}' AND idioma_id = '".SWPHP_IDIOMA_POR_DEFECTO."'"
				);
		if(is_array($aux))
		{
			foreach($aux as $key=>$value)
			{
				$rows[$c][$key] = $value;
			}
		}

		//Padre
		$rows[$c]['padre'] = $rows[$c]['padre_id'] > 0 ?
			($rows[$c]['padre'] = $rows[$c]['padre_pagina_id'] > 0 ?
				$db->GetValueQuery("SELECT textoenlace"
					." FROM ".SWPHP_DBPREFIX."paginas_idiomas"
					." WHERE pagina_id = '{$rows[$c]['padre_pagina_id']}' AND idioma_id = '".SWPHP_IDIOMA_POR_DEFECTO."'"
					)
				:
				$db->GetValueQuery("SELECT textoenlace"
					." FROM ".SWPHP_DBPREFIX."menuprincipal_idiomas"
					." WHERE menuprincipal_id = '{$rows[$c]['padre_id']}' AND idioma_id = '".SWPHP_IDIOMA_POR_DEFECTO."'"
					))
			:
			'';

		//Ordenación
		if($rows[$c]['padre_id'] != $padre_id)
		{
			$padre_id = $rows[$c]['padre_id'];

			$rows[$c]['subir'] = false;
			$rows[$c-1]['bajar'] = false;
		}
		else
		{
			$rows[$c]['subir'] = !($c == 0);
		}

		$rows[$c]['bajar'] = !($c == $size-1);
	}

	/*
	$rows = $db->GetRows("SELECT m.id, m.padre_id, m.pagina_id, fi.textoenlace AS padre, pi.titulo, pi.textoenlace, p.activo"
		." FROM ".SWPHP_DBPREFIX."menuprincipal AS m"
		." LEFT JOIN ".SWPHP_DBPREFIX."menuprincipal AS n ON n.id = m.padre_id"
		." LEFT JOIN ".SWPHP_DBPREFIX."paginas_idiomas AS fi ON fi.pagina_id = n.pagina_id AND fi.idioma_id = '".SWPHP_IDIOMA_POR_DEFECTO."'"
		." LEFT JOIN ".SWPHP_DBPREFIX."paginas AS p ON p.id = m.pagina_id"
		." LEFT JOIN ".SWPHP_DBPREFIX."paginas_idiomas AS pi ON pi.pagina_id = p.id AND pi.idioma_id = '".SWPHP_IDIOMA_POR_DEFECTO."'"
		." ORDER BY m.padre_id, m.peso, m.id");
	*/

	$smarty->assign("rows", $rows);
}
?>
