<?php
/**
 * José Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2012-10-10
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/traducciones/admin/index.php
 *
 */

$q = isset($_GET["q"]) && !empty($_GET["q"]) ? str_replace(array("\\/'\";"), "", $_GET["q"]) : '';
$l = isset($_GET["l"]) && !empty($_GET["l"]) ? str_replace(array("\\/'\";"), "", $_GET["l"]) : '';
$frases = false;

switch($q)
{
	case '':
		//nada
		break;
	default:
		$qA = mb_substr($q, 0, 4);
		$qB = mb_substr($q, 4);

		switch($qA)
		{
			case 'the_':
				$clave = 'theme';
				$dirPHP = false;
				$dirTPL = SWPHP_THEMES_DIR.$qB.'/tpl';
				break;
			case 'mod_':
				$clave = $qB;
				$dirPHP = SWPHP_MODULES_DIR.$qB;
				$dirTPL = SWPHP_MODULES_DIR.$qB.'/tpl'; //Los tpl personalizados en el theme se buscan dentro de GetFrases
				break;
			default:
				$clave = '';
				$dirPHP = false;
				$dirTPL = false;
				break;
		}

		//Coger frases para traducir
		$aux = traducciones_GetFrases($dirPHP, $dirTPL, $clave);
		$frases = array(); //para que ya no sea false

		//Guardar traducciones
		if(isset($_POST['sent']) && isset($_POST['frases']))
		{
			$content = '<?php
global $swphp_lang;';
			for($c=0,$size=sizeof($aux); $c<$size; $c++)
			{
				$content .= sprintf('
$swphp_lang[\'%s\'] = \'%s\';', md5($qB.$aux[$c]), addcslashes($_POST['frases'][$c], "'"));
			}
			$content .= '
?>';
			$file = ($clave == 'theme') ?
				SWPHP_THEMES_DIR.$qB.'lang/'.$l.'/index.php'
				:
				SWPHP_THEME_DIR.'lang/modulos/'.$qB.'/'.$l.'/index.php';
			if(!makeDir(dirname($file)) || file_put_contents($file, $content) === false)
			{
				SWPHP::_Msg('No se pudo guardar', 'error');
			}
			else
			{
				SWPHP::_Msg('Guardado correctamente', 'check');
			}
		}

		//Cargar traducciones
		$lang = traducciones_GetLang($clave, $qB, $l); //$clave == 'theme' ? 'theme' : 'module'
		foreach($aux as $frase)
		{
			$hash = md5($qB.$frase);
			$frases[$frase] = isset($lang[$hash]) ? $lang[$hash] : $frase; //TODO: ¿Traducción automática?
		}

		break;
}

$smarty->assign(array(
	'q'=>$q,
	'l'=>$l,
	'themes'=>SWPHP::_GetThemes(),
	'modulos'=>SWPHP::_GetModulos(),
	'idiomas'=>$swphp_idiomas,
	'frases'=>$frases,
	));

$admin_template = "{$swphp_module_templates_dir}admin/traducciones.tpl";
?>